//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef __EVENTS_H__
#define __EVENTS_H__

#include <SDL.h>

// on dclare ici _TOUS_ les defines des vnements du logiciel (event->user)
enum enum_Event
{
	EVENT_0,
// -------------------------------------------------------------------------- //
    EVENT_CREATE_VUE_GENERIQUE_DEBUT,
    EVENT_CREATE_VUE_GENERIQUE_FIN,
    EVENT_CREATE_VUE_MAIN_MENU,
	EVENT_CREATE_VUE_GAME,
	EVENT_CREATE_VUE_NIVEAU,
	EVENT_CREATE_VUE_OPTION,
	EVENT_CREATE_VUE_CONSTRUCTION,
	EVENT_CREATE_VUE_SOUSOPTION,
	EVENT_CREATE_VUE_CHOIX_COULEUR_PIECE,
	EVENT_CREATE_VUE_CHOIX_LANGUE,
	EVENT_CREATE_VUE_CHOIX_JOUER,
    EVENT_CREATE_VUE_CREDITS,
#ifndef Nokia770
    EVENT_CREATE_VUE_LOGIN,
    EVENT_CREATE_VUE_CHOIXADVERSAIRE,
	EVENT_CREATE_VUE_CHOIX_MODE_VIDEO,
	EVENT_CREATE_VUE_HOW_TO_PLAY,
#endif
// -------------------------------------------------------------------------- //
	EVENT_MENU_JOUER,
	EVENT_MENU_NIVEAU,
	EVENT_MENU_STATS,
	EVENT_MENU_OPTIONS,
#ifndef Nokia770
	EVENT_MENU_HOWPLAY,
#endif
	EVENT_MENU_QUITTER,
// -------------------------------------------------------------------------- //
	EVENT_NIVEAU_FACILE,
	EVENT_NIVEAU_MOYEN,
	EVENT_NIVEAU_DIFFICILE,
	EVENT_NIVEAU_IMPOSSIBLE,
// -------------------------------------------------------------------------- //
	EVENT_GAME_PARTIE_START,
	EVENT_GAME_QUICOMMENCE,
	EVENT_GAME_FIRST_PIECE_WAIT,
	EVENT_GAME_PIECE_WAIT,
	EVENT_GAME_PIECE_SELECTED,
	EVENT_GAME_CERCLE_WAIT,
	EVENT_GAME_CERCLE_SELECTED,
	EVENT_GAME_PARTIE_WIN,
	EVENT_GAME_PARTIE_LOST,
	EVENT_GAME_PARTIE_NULLE,
	EVENT_GAME_PARTIE_END,
	EVENT_GAME_CHANGE_PLAYER,
	EVENT_GAME_CONTINUER_PARTIE,
#ifndef Nokia770
	EVENT_GAME_PING,
	EVENT_GAME_NEW_PARTIE,
	EVENT_GAME_JE_VEUX_PLUS_NEW_PARTIE,
    EVENT_GAME_REPONSE_NEW_PARTIE_OUI,
    EVENT_GAME_REPONSE_NEW_PARTIE_NON,
#endif
// -------------------------------------------------------------------------- //
#ifndef Nokia770
	EVENT_OPTION_JOUEUR,
#endif
	EVENT_OPTION_MUSIQUE,
	EVENT_OPTION_VUE_DESSUS,
// -------------------------------------------------------------------------- //
	EVENT_JOUEUR_G,
	EVENT_JOUEUR_D,
	EVENT_MUSIQUE_ON,
	EVENT_MUSIQUE_OFF,
	EVENT_VUEDESSUS_ON,
	EVENT_VUEDESSUS_OFF,
// -------------------------------------------------------------------------- //
	EVENT_CHOIX_COLOR_PC_1,
	EVENT_CHOIX_COLOR_PC_2,
// -------------------------------------------------------------------------- //
    EVENT_JOUEUR_QUICOMMENCE_OK,
// -------------------------------------------------------------------------- //
	EVENT_CHOIX_LANGUE,
// -------------------------------------------------------------------------- //
#ifndef Nokia770
	EVENT_LOGIN_LOGIN,
	EVENT_LOGIN_PASS,
	EVENT_LOGIN_VALIDE,
// -------------------------------------------------------------------------- //
    EVENT_CHX_ADV_RECUP_LISTE_JOUEUR,
    EVENT_CHX_ADV_QUI_VEUX_JOUER_WAIT,
    EVENT_CHX_ADV_RAFRAICHIR_LISTE,
    EVENT_CHX_ADV_PP_CHOIX_JOUER_AVEC_NOUS_ACCEPTER,
    EVENT_CHX_ADV_PP_CHOIX_JOUER_AVEC_NOUS_REFUSER,
    EVENT_CHX_ADV_JE_VEUX_JOUER,
    EVENT_CHX_ADV_JE_VEUX_PLUS_JOUER,
// -------------------------------------------------------------------------- //
	EVENT_MODE_VIDEO_FULL_SCREEN,
	EVENT_MODE_VIDEO_FENETRE,
#endif
// -------------------------------------------------------------------------- //
	EVENT_CLOSE_POPUP,
	EVENT_QUITTER,
// -------------------------------------------------------------------------- //
	EVENT_TIMER,
// -------------------------------------------------------------------------- //
	EVENT_MAX
};

// Offre des fonctions utiles pour la gestion des vnements
class Events
{
  //*******************
  //* variables membres
	private:
        static Events *_Singleton;

  //*******************
  //* fonctions membres
	public:
        static Events *getInstance ();
        static void kill ();

		void addEvent(Uint32 event_code);
		void addEvent(Uint32 event_code, void *data1);
		void addEvent(Uint32 event_code, void *data1, void *data2);

    private:
		Events();
		~Events();
};

#endif // __EVENTS_H__
