//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef __FOND_H__
#define __FOND_H__

#include <string>

#include <SDL.h>

#include "Screen.h"
#include "Lineo.h"

#define FOND_RECT_SRC 0
#define FOND_RECT_DST 1

// liste des types, mais comme le max servira dans un tableau contenant
// les diffrents types, il ne faut rien mettre d'autre que des menus
// supplmentaires dans cet enum...
enum enum_Fond_Types
{
// ------------------ LISTE DES DIFFERENTS FONDS ---------------------------- //
	FOND_MENU,
	FOND_SAISIE,
	FOND_TABLEAU,
	FOND_TABLEAU_LIGNE,
	FOND_POPUP_ERREUR,
	FOND_POPUP_ERREUR_BTN_ON,
	FOND_POPUP_ERREUR_BTN_OUT,
	FOND_POPUP_WARNING,
	FOND_POPUP_WARNING_BTN_ON,
	FOND_POPUP_WARNING_BTN_OUT,
	FOND_POPUP_INFO,
	FOND_POPUP_INFO_BTN_ON,
	FOND_POPUP_INFO_BTN_OUT,
// -------------------------------------------------------------------------- //
	FOND_TYPE_MAX,
};

using namespace std;

// affiche un fond sous un menu ou sous autre chose
// elle est fige quand  l'apparence, elle permet simplement de dimensionner
// et d'afficher ce fond qui est d'aprs une image "fond_menu.png"
class Fond
{
  //*******************
  //* variables membres
	private:
	    Uint8      _Type;

        string      _ImgName;
        Uint16      _ImgW;
        Uint16      _ImgH;
        Uint16      _ImgMargeG;
        Uint16      _ImgMargeD;
        Uint16      _ImgMargeH;
        Uint16      _ImgMargeB;

        string      _SpriteName;

        SDL_Rect    _Contour;
        Uint32      _ZIndex;

        // chaque rectangle est un tableau de 2 ([0=FOND_RECT_SRC]=source;[1=FOND_RECT_DST]=destination)
        SDL_Rect    _HautGaucheRect[2];
        SDL_Rect    _HautRect[2];
        SDL_Rect    _HautDroitRect[2];
        SDL_Rect    _DroitRect[2];
        SDL_Rect    _BasDroitRect[2];
        SDL_Rect    _BasRect[2];
        SDL_Rect    _BasGaucheRect[2];
        SDL_Rect    _GaucheRect[2];
        SDL_Rect    _CentreRect[2];

  //*******************
  //* fonctions membres
	public:
		Fond(Uint8 type, SDL_Rect contour, Uint32 z_index);
		~Fond();
		void mov(Sint32 offset_x, Sint32 offset_y);
		void setZIndex(Uint32 z_index);

	private:
		void init(void); // initialise les rectangles src et dst
        void draw(void); // affiche le fond  l'cran
};

#endif // __FOND_H__
