//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  SFont
//  Copyright (C) 2003 Karl Bartel <karlb@gmx.net>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

//
// ***************************************************************************************
// inspired of the work of Karl Bartel in SFont - LGPL - http://www.linux-games.com/sfont/
// also of Ilana Rudnik for Unicode - irudnik@itsgames.com
// ***************************************************************************************

#ifndef __FONT_H__
#define __FONT_H__

#include <algorithm>
#include <string>
#include <vector>
#include <sstream>
#include <iostream>

#include <SDL.h>

#include "Defines.h"
#include "Screen.h"
#include "Templates.h"

#define FONT_12_WHITE 	"FONT_12_WHITE"
#define FONT_18_WHITE 	"FONT_18_WHITE"
#define FONT_24_WHITE   "FONT_24_WHITE"
#define FONT_26_WHITE   "FONT_26_WHITE"
#define FONT_26_YELLOW  "FONT_26_YELLOW"
#define FONT_28_WHITE   "FONT_28_WHITE"
#define FONT_36_WHITE   "FONT_36_WHITE"
#define FONT_36_YELLOW  "FONT_36_YELLOW"
#define FONT_58_WHITE   "FONT_58_WHITE"

using namespace std;

typedef Uint16 Uchar;

class Font
{
  //*******************
  //* variables membres
    private:
	    int _CharPos[2][512];
	    int _MaxPos[2];
	    string _Name;
	    string _NameSurface[2];
	    Uint32 _SurfaceW[2];
	    Uint32 _SurfaceH[2];

  //*******************
  //* fonctions membres
	public:
		Font(string name, string name_surface, string ext);
		Font(string name); // !!!! ne doit tre utilis que pour des find !!!!!
        ~Font();
		void movPhrase(string phrase, Uint32 id_phrase, Sint32 offset_x, Sint32 offset_y); // dplace un texte selon un offset
		void setPhraseZIndex(string phrase, Uint32 id_phrase, Uint32 new_z_index); // modifie le z_index d'une phrase
        void delPhrase(string phrase, Uint32 id_phrase); // supprime une phrase
   		Uint16 getPhraseWidth(string phrase); // donne la largeur d'une phrase en pixel
   		Uint16 getHeight();
   		void phraseToImages(string phrase, Uint32 id_phrase, SDL_Rect rect, Uint32 z_index); // transforme une phrase en autant d'image qu'il y a de lettres

        // Oprateur d'galit :
        bool operator==(const Font &font) const
        {
            return (_Name == font._Name);
        }

	private:
        int getPixel(SDL_Surface *surface, Sint32 x, Sint32 y);
   		void getCharIndex(Uchar inchar, int *fontindex, int *charindex);
};

#endif // __FONT_H__
