//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA



#ifndef __MINI_PIECE_H__
#define __MINI_PIECE_H__

#include <string>

#include <SDL.h>

#include "Screen.h"
#include "Templates.h"
#include "Config.h"

#include "Piece.h" // afin de rcuprer tous les defines de formes de pice

#define MINIP_OFFSET_GRANDE_X 14
#define MINIP_OFFSET_GRANDE_Y 14
#define MINIP_OFFSET_PETITE_X  9
#define MINIP_OFFSET_PETITE_Y  9

#define MINIP_OFFSET_CONTOUR_GRANDE_X 20
#define MINIP_OFFSET_CONTOUR_GRANDE_Y 20
#define MINIP_OFFSET_CONTOUR_PETITE_X 15
#define MINIP_OFFSET_CONTOUR_PETITE_Y 15


using namespace std;

// Contient toutes les donnes ncessaires pour crer n'importe quelle des 16 pices du plateau
// mais ces pice sont miniature et en vue de dessus
class MiniPiece
{
  //*******************
  //* variables membres
    private:
        Uint8       _Forme;

        SDL_Rect    _RecDes;
        SDL_Rect    _RecSrc;

        SDL_Rect    _RecDesCont;
        SDL_Rect    _RecSrcCont;

        Uint16      _OffsetX;
        Uint16      _OffsetY;

        Uint16      _OffsetXCont;
        Uint16      _OffsetYCont;

        string 		_SurfaceName;
        string 		_SpriteName;

        string 		_SurfaceNameCont;
        string 		_SpriteNameCont;

        Uint16      _PosPointX;
        Uint16      _PosPointY;

        Uint32      _ZIndex;

        bool        _Selected;
        bool        _OnScreen;

  //*******************
  //* fonctions membres
    public:
		MiniPiece(Uint8 forme);
		~MiniPiece();
		void drawScreen(Uint16 x, Uint16 y, Uint32 z_index);
        void freeScreen(void);
        void setSelected(bool selected);

        inline Uint8 getForme(){
            return _Forme;
        }
};

#endif // __MINI_PIECE_H__
