//  Linéo
//  Copyright (C) 2006-2007 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Linéo.
//
//  Linéo is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Linéo is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Linéo; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef MUSIQUE_H
#define MUSIQUE_H

#include <SDL.h>
#include <SDL_thread.h>
#include <SDL_mixer.h>

#include <string>

#include "Defines.h"

#define MUSIQUE_MENUS       "musique.ogg"
#define MUSIQUE_INTRO_GAME  "intro_partie.ogg"

using namespace std;

// classe selon le design-pattern Singleton
class Musique
{
  //*******************
  //* variables membres
  private:
    Mix_Music      *_Music; // la musique chargée
    string          _FileName; // nom du fichier de la musique
    static Musique *_Singleton;
    Uint32          _Duration;
    SDL_Thread 	   *_Thread;

  //*******************
  //* fonctions membres
  public:
    static Musique *getInstance ();
    static void kill ();

    void init(string file_name);
    void play();
    void play(int loop);
    void stop();
    void decrechendo(Uint32 duration);
    int decrechendoThread(void *data);

  private:
    Musique();
    ~Musique();

    static int staticDecrechendo( void *Param ){
        Musique* Obj = reinterpret_cast<Musique*>( Param );
        return Obj->decrechendoThread(Param);
    }
};

#endif // MUSIQUE_H
