//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __PHRASE_H__
#define __PHRASE_H__

#include <string>

#include <SDL.h>

using namespace std;

// No description
class Phrase
{
  //*******************
  //* variables membres
    private:
        string 		_Phrase;
        Uint32 		_UniqueId; // c'est cet identifiant qui permet de pointer sur cette classe prcise plus tard
        SDL_Rect 	_Rect;

  //*******************
  //* fonctions membres
	public:
		Phrase(string phrase/*, SDL_Rect rect_text*/);
		Phrase(Uint32 unique_id); // !!!! ne doit tre utilis que pour des find !!!!!
		~Phrase();

		const SDL_Rect getRect(){
            return _Rect;
        }
		void setRect(SDL_Rect rect){
            _Rect=rect;
        }

		const Uint32 getUniqueId(){
            return _UniqueId;
        }
		const string getPhrase(){
            return _Phrase;
        }
		// Oprateur d'galit :
        bool operator==(const Phrase &phrase) const
        {
            return (_UniqueId == phrase._UniqueId);
        }
};

#endif // __PHRASE_H__
