//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA



#ifndef __PIECE_H__
#define __PIECE_H__

#include <string>

#include <SDL.h>

#include "Screen.h"
#include "Templates.h"
#include "Config.h"

#define P_NO_FORME       0x00
#define P_FORME_ROND     0x01
#define P_FORME_CARRE    0x02
#define P_FORME_PETITE   0x04
#define P_FORME_GRANDE   0x08
#define P_FORME_COLOR_1  0x10
#define P_FORME_COLOR_2  0x20
#define P_FORME_PLEINE   0x40
#define P_FORME_CREUSE   0x80


using namespace std;

// Contient toutes les donnes ncessaires pour crer n'importe quelle des 16 pices du plateau
class Piece
{
  //*******************
  //* variables membres
    private:
        Uint8       _Forme;

        SDL_Rect    _RecDes;
        SDL_Rect    _RecSrc;

        SDL_Rect    _RecDesCreu;
        SDL_Rect    _RecSrcCreu;

        SDL_Rect    _RecDesCont;
        SDL_Rect    _RecSrcCont;

        Uint16      _OffsetX;
        Uint16      _OffsetY;

        Uint16      _OffsetXCreu;
        Uint16      _OffsetYCreu;

        Uint16      _OffsetXCont;
        Uint16      _OffsetYCont;

        string 		_SurfaceName;
        string 		_SpriteName;

        string 		_SurfaceNameCont;
        string 		_SpriteNameCont;

        Uint16      _PosPointX;
        Uint16      _PosPointY;

        Uint32      _ZIndex;

        bool        _Selected;
        bool        _OnScreen;

  //*******************
  //* fonctions membres
    public:
		Piece(Uint8 forme);
		~Piece();
		void drawScreen(Uint16 x, Uint16 y, Uint32 z_index);
		void updateScreen(Uint16 x, Uint16 y, Uint32 z_index);
        void freeScreen(void);
        bool testSurvol(Uint16 x_mouse, Uint16 y_mouse); // dtecte si on survol la pice (true) ou non (false)
        void setSelected(bool selected);

        inline Uint8 getForme(){
            return _Forme;
        }
};

#endif // __PIECE_H__
