//  Linéo
//  Copyright (C) 2007 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Linéo.
//
//  Linéo is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Linéo is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Linéo; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SAMPLE_H
#define SAMPLE_H

#include <SDL.h>
#include <SDL_mixer.h>

#include <string>

#include "Defines.h"

#define SAMPLE_GAGNE           "gagne.wav"
#define SAMPLE_MENU_1          "menu1.wav"
#define SAMPLE_MENU_2          "menu2.wav"
#define SAMPLE_MENU_3          "menu3.wav"
#define SAMPLE_MENU_4          "menu4.wav"
#define SAMPLE_MENU_5          "menu5.wav"
#define SAMPLE_MENU_6          "menu6.wav"
#define SAMPLE_MENU_CLICK      "menu_click.wav"
#define SAMPLE_PERDU           "perdu.wav"
#define SAMPLE_PIECE_POSEE_J1  "piece_posee_joueur1.wav"
#define SAMPLE_PIECE_POSEE_J2  "piece_posee_joueur2.wav"
#define SAMPLE_PLATEAU_TOURNE  "plateau_tourne.wav"

using namespace std;

// classe selon le design-pattern Singleton
class Sample
{
  //*******************
  //* variables membres
  private:
    static Sample *_Singleton;

  //*******************
  //* fonctions membres
  public:
    static Sample *getInstance ();
    static void kill();

    void play(string file_name);

  private:
    Sample();
    ~Sample();

};

#endif // SAMPLE_H
