//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef __SPRITE_H__
#define __SPRITE_H__

#include <vector>
#include <string>

#include <SDL.h>

using namespace std;

// en fait un sprite est compos d'une ou plusieurs images tires d'une seule surface
// une seule image peut tre affiche  la fois et elle est dfinie par _Current
class Sprite
{
  //*******************
  //* variables membres
	private:
		typedef vector<SDL_Rect> vSDLRect;
		string 		_Name;
        Uint32      _IndexSurface;
        vSDLRect    _RectSrc;
		vSDLRect    _RectDest;
		Sint32      _Current;
		Uint32      _ZIndex;
		bool        _noCurrent; // on liste toutes les images (true) sinon on utilise l'image de current (false)

  //*******************
  //* fonctions membres        
	public:
		Sprite(Uint32 index_surface, string name);
		Sprite(string name);
		~Sprite();
		void setCurrent(Uint16 x);
		void addImage(SDL_Rect rect_src, SDL_Rect rect_dest);
		void movAllImages(Sint32 offset_x, Sint32 offset_y);
		void setZIndex(Uint32 z);
		void setPosXY(Uint16 new_x, Uint16 new_y);
		bool blitOnSurface(SDL_Surface* surface_src,SDL_Surface* surface_des);
		
		Uint32 getIndexSurface()
		{
			return _IndexSurface;
		}
        const void noCurrent()
		{
			_noCurrent = true;
		}
        const Uint32 getZIndex()
		{
			return _ZIndex;
		}
		// Oprateur d'galit :
        bool operator==(const Sprite &sprite) const
        {
            return (_Name == sprite._Name);
        }
		
};

#endif // __SPRITE_H__

