//  Lino
//  Copyright (C) 2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VUECHOIXADVERSAIRE_H__
#define __VUECHOIXADVERSAIRE_H__

#include "Menu.h"
#include "FondEcran.h"
#include "Langue.h"
#include "ComReseau.h"
#include "Events.h"
#include "VueChoixJouer.h"
#include <SDL_thread.h>

enum enum_Joueur_Threads_Etats
{
    VCXADV_NO_ETAT,
    VCXADV_JOUEUR_EN_ATTENTE,
    VCXADV_QUI_VEUX_JOUER_WAIT,
    VCXADV_REPONSE_JOUER_OUI,
    VCXADV_REPONSE_JOUER_NON,
    VCXADV_JE_VEUX_JOUER,
    VCXADV_JE_VEUX_PLUS_JOUER
};

typedef vector<string> vstring;


// Gre la vue du menu principal
class VueChoixAdversaire
{
  //*******************
  //* variables membres
	private:
        Menu 		*_Menu;
        FondEcran 	*_FondEcran;
        ComReseau   *_ComReseau;
        vstring     _Liste;

        SDL_Thread 	*_Thread;
        Uint16      _ThreadEtat;
        bool        _StopThread;


        string      _JoueurVeuxJouer;
        Uint8       _ModeVueGameReseau;
        Uint8       _NoItemListe;

  //*******************
  //* fonctions membres
    private:
        void executeThread(Uint16 thread_etat);
        static int staticThread( void *Param ){
            VueChoixAdversaire* Obj = reinterpret_cast<VueChoixAdversaire*>( Param );
            return Obj->thread(Param);
        }
        int thread(void *Param);

	public:
		VueChoixAdversaire();
		~VueChoixAdversaire();
		void processEvents(SDL_Event *event);
};

#endif // __VUECHOIXADVERSAIRE_H__
