//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2006 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "VueChoixJouer.h"

VueChoixJouer::VueChoixJouer()
{
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(FD_ECR_VIERGE|FD_ECR_LINEO_SMALL);
    // on initialise le menu
    _Menu = new Menu(Langue::getInstance()->get("Jouer une partie"), true, EVENT_CREATE_VUE_MAIN_MENU);
    _Menu->addItem(Langue::getInstance()->get("Humain contre I.A."),EVENT_CREATE_VUE_GAME,MENU_TYPE_LIEN,CHOIX_JOUER_MODE_1_JOUEUR);
    _Menu->addItem(Langue::getInstance()->get("Humain contre Humain"),EVENT_CREATE_VUE_GAME,MENU_TYPE_LIEN,CHOIX_JOUER_MODE_2_JOUEURS);
#ifndef Nokia770
    if(Lineo::getInstance()->_SessionReseau=="NULL" || Lineo::getInstance()->_SessionReseau==""){
        _Menu->addItem(Langue::getInstance()->get("En ligne"),EVENT_CREATE_VUE_LOGIN,MENU_TYPE_LIEN);
    }
    else {
        _Menu->addItem(Langue::getInstance()->get("En ligne"),EVENT_CREATE_VUE_CHOIXADVERSAIRE,MENU_TYPE_LIEN);
    }
#endif
    _Menu->draw();
}

VueChoixJouer::~VueChoixJouer()
{
    // on supprime toutes les classes
	delete(_FondEcran);
    delete(_Menu);
}

// gre les vnements de la vue
void VueChoixJouer::processEvents(SDL_Event *event)
{
    _Menu->processEvents(event);
}
