//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VUE_CHOIX_LANGUE_H__
#define __VUE_CHOIX_LANGUE_H__

#include <SDL.h>

#include "Defines.h"
#include "Screen.h"
#include "Menu.h"
#include "Config.h"
#include "FondEcran.h"
#include "Langue.h"


using namespace std;

typedef map<string, string>         mapSS;
typedef mapSS::iterator             mapSSit;


// permet  l'utilisateur de choisir la langue du jeu  l'aide de drapeaux
class VueChoixLangue
{
  //*******************
  //* variables membres
	private:
        Menu* 			_Menu;
        FondEcran* 		_FondEcran;

        mapSS           _ListeLang;
        mapSSit         _ListeLangIter;

		Uint8 			_NoItemLang;

  //*******************
  //* fonctions membres
	public:
		VueChoixLangue();
		~VueChoixLangue();
		void processEvents(SDL_Event *event);

	private:
		mapSSit listeLangNext(mapSSit current_iter); // permet d'aller  l'itrateur suivant, ou retourner au premier si le dernier est atteind
		mapSSit listeLangPrev(mapSSit current_iter); // permet d'aller  l'itrateur prcdent, ou retourner au dernier si le premier est atteind

		mapSSit getItVectLang(string lang);// rcupre l'itrateur d'une langue dans la liste
};

#endif // __VUE_CHOIX_LANGUE_H__
