//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VUEDESSUS_H__
#define __VUEDESSUS_H__

#include <string>

#include <SDL.h>

#include "Defines.h"
#include "Screen.h"
#include "MiniPiece.h"
#include "GamePlateau.h" // au moins pour struct point2D

#define VD_OFFSET_X  617
#define VD_OFFSET_Y   10

#define VD_OFFSET_PT_0_X  27
#define VD_OFFSET_PT_0_Y  28
#define VD_DST_ENTRE_PT   40


// Gre l'affichage de la vue de dessus du plateau de jeu avec ses pices
// IMPORTANT !!!
// ==> toutes les coordonnes exprimes sont relatives au coin suprieur gauche de la vue de dessus
// il n'y a que ce point qui est situ par rapport  la vue entire du jeu
class VueDessus
{
  //*******************
  //* variables membres
	private:
        point2D     _PlateauPoints[4][4];
        MiniPiece*  _PlateauPieces[4][4];

  //*******************
  //* fonctions membres
	public:
		VueDessus();
		~VueDessus();

        void addPlateauPiece(Uint8 i, Uint8 j, Uint8 forme);
        void delPlateauPiece(Uint8 i, Uint8 j);
        void setLineo(Uint8 i, Uint8 j);
};

#endif // __VUEDESSUS_H__
