//  Lino
//  Copyright (C) 2005-2008 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VUEGAME_H__
#define __VUEGAME_H__

#include <vector>
#include <ctime>
#include <cstdlib>

#include <SDL.h>
#include <SDL_thread.h>

#include "Defines.h"
#include "Screen.h"
#include "Events.h"
#include "VFont.h"
#include "FondEcran.h"
#include "LaDonne.h"
#include "Joueur.h"
#include "Config.h"
#include "VueChoixJouer.h"
#include "VueDessus.h"
#include "Menu.h"
#include "Langue.h"
#include "Musique.h"
#include "Sample.h"

#define FLECHE_D " "
#define FLECHE_G " "
#define PAS_DE_VALEUR 123

#define VGAME_FONT_JOUEUR FONT_26_WHITE

class Joueur;
class GamePlateau;

using namespace std;

// No description
class VueGame
{
  //*******************
  //* variables membres
	private:
		Uint8           _ModeJeu;
		Uint8           _QuiCommence;

        GamePlateau    *_GamePlateau;
        LaDonne 	   *_LaDonne; // permet de savoir au fur et  mesure de la partie o sont les pices

        VueDessus 	   *_VueDessus; // permet d'afficher une vue de dessus
        bool        	_DisplayVueDessus; // suivant ce paramtre on affiche ou non la vue de dessus

        Joueur 		   *_PlayerCurrent;
        Joueur 		   *_PlayerG; // joueur de gauche
        Joueur 		   *_PlayerD; // joueur de droite
		Uint32 			_TxtPlayerGId;
		Uint32 			_TxtPlayerDId;

        bool        	_FlagEndGame;
        bool        	_FlagEventGamePieceWait;
        SDL_Thread 	   *_Thread;
        bool            _StopThread;

        string 			_PhraseLineo;
		Uint32 			_PhraseLineoId;

        Menu		   *_MenuFin;
        FondEcran	   *_FondEcran;

  //*******************
  //* fonctions membres
	public:
		VueGame(Uint8 mode_jeu);
		~VueGame();
		void processEvents(SDL_Event *event);

        inline bool getStopThread(){
			return _StopThread;
		}

    private:
        static int staticJoueurFirstThread( void *Param ){
            VueGame* Obj = reinterpret_cast<VueGame*>( Param );
            return Obj->joueurFirstThread(Param);
        }

        static int staticJoueurThread( void *Param ){
            VueGame* Obj = reinterpret_cast<VueGame*>( Param );
            return Obj->joueurThread(Param);
        }

        int joueurFirstThread(void *data);
        int joueurThread(void *data);
        void showVueDessus(void);
        void removeVueDessus(void);
        void playSamplePiecePosee(void);
};

#endif // __VUEGAME_H__
