//  Linéo
//  Copyright (C) 2005-2007 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Linéo.
//
//  Linéo is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Linéo is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Linéo; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "VueMainMenu.h"

VueMainMenu::VueMainMenu()
{
    // on initialise le fond d'écran
    _FondEcran = new FondEcran(FD_ECR_VIERGE|FD_ECR_LINEO_SMALL);
    // on initialise le menu
    _Menu = new Menu(Langue::getInstance()->get("Menu") , false, 0);
    Uint8 it1 = _Menu->addItem(Langue::getInstance()->get("Jouer une partie"),EVENT_CREATE_VUE_CHOIX_JOUER);
    _Menu->changeItemSample(it1, SAMPLE_MENU_1);
    Uint8 it2 = _Menu->addItem(Langue::getInstance()->get("Niveau"),EVENT_CREATE_VUE_NIVEAU);
    _Menu->changeItemSample(it2, SAMPLE_MENU_2);
//    _Menu->addItem(Langue::getInstance()->get("Statistiques"),EVENT_CREATE_VUE_CONSTRUCTION,MENU_TYPE_LIEN,EVENT_CREATE_VUE_MAIN_MENU);
    Uint8 it3 = _Menu->addItem(Langue::getInstance()->get("Options"),EVENT_CREATE_VUE_OPTION);
    _Menu->changeItemSample(it3, SAMPLE_MENU_3);
#ifndef Nokia770
    Uint8 it4 = _Menu->addItem(Langue::getInstance()->get("Comment jouer..."),EVENT_CREATE_VUE_HOW_TO_PLAY);
    _Menu->changeItemSample(it4, SAMPLE_MENU_4);
#endif
    Uint8 it5 = _Menu->addItem(Langue::getInstance()->get("Credits"),EVENT_CREATE_VUE_CREDITS,MENU_TYPE_LIEN,EVENT_CREATE_VUE_MAIN_MENU);
    _Menu->changeItemSample(it5, SAMPLE_MENU_5);
    Uint8 it6 = _Menu->addItem(Langue::getInstance()->get("Quitter"),EVENT_CREATE_VUE_GENERIQUE_FIN);
    _Menu->changeItemSample(it6, SAMPLE_MENU_6);
    // puis on l'affiche
    _Menu->draw();
}

VueMainMenu::~VueMainMenu()
{
    // on supprime toutes les classes
	delete(_FondEcran);
    delete(_Menu);
}

// gère les évènements de la vue
void VueMainMenu::processEvents(SDL_Event *event)
{
    _Menu->processEvents(event);
}
