//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "VueNiveau.h"

VueNiveau::VueNiveau()
{
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(FD_ECR_VIERGE|FD_ECR_LINEO_SMALL);
    // on initialise le _Menu
    _Menu = new Menu(Langue::getInstance()->get("Niveau"), true, EVENT_CREATE_VUE_MAIN_MENU);
    _NoItemFacile     = _Menu->addItem(Langue::getInstance()->get("Facile"),EVENT_NIVEAU_FACILE,MENU_TYPE_RADIO);
    _NoItemMoyen      = _Menu->addItem(Langue::getInstance()->get("Moyen"),EVENT_NIVEAU_MOYEN,MENU_TYPE_RADIO);
    _NoItemDifficile  = _Menu->addItem(Langue::getInstance()->get("Difficile"),EVENT_NIVEAU_DIFFICILE,MENU_TYPE_RADIO);
    _NoItemImpossible = _Menu->addItem(Langue::getInstance()->get("ImPoSsIbLe"),EVENT_NIVEAU_IMPOSSIBLE,MENU_TYPE_RADIO);
    _Menu->draw();
    // puis on positionne le radio bouton
    // en renseignant le niveau de la config
    string niveau_config = Config::getInstance()->get("niveau");
    if(niveau_config == "facile"){
        _Menu->setItemOn(_NoItemFacile);
    }else if(niveau_config == "difficile"){
        _Menu->setItemOn(_NoItemDifficile);
    }else if(niveau_config == "impossible"){
        _Menu->setItemOn(_NoItemImpossible);
    }else{ // moyen par defaut
        _Menu->setItemOn(_NoItemMoyen);
    }
}

VueNiveau::~VueNiveau()
{
    // on libre les pointeurs des classes
	delete(_FondEcran);
    delete(_Menu);
}

// gre les vnements de la vue
void VueNiveau::processEvents(SDL_Event *event)
{
    // on s'occupe de notre vue en premier
    switch (event->type) {
        case SDL_USEREVENT:
            switch (event->user.code)
            {
                case EVENT_NIVEAU_FACILE:
                    _Menu->setItemOn(_NoItemFacile);
                    Config::getInstance()->set("niveau","facile");
                break;
                case EVENT_NIVEAU_MOYEN:
                    _Menu->setItemOn(_NoItemMoyen);
                    Config::getInstance()->set("niveau","moyen");
                break;
                case EVENT_NIVEAU_DIFFICILE:
                    _Menu->setItemOn(_NoItemDifficile);
                    Config::getInstance()->set("niveau","difficile");
                break;
                case EVENT_NIVEAU_IMPOSSIBLE:
                    _Menu->setItemOn(_NoItemImpossible);
                    Config::getInstance()->set("niveau","impossible");
                break;
            }
        break;
   	}
   	// puis du _Menu
    _Menu->processEvents(event);
}
